/***************************************************************************
**
**  This file is part of HVCore.
**
**  HVCore is free software: you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation, either version 3 of the License, or
**  (at your option) any later version.
**
**  HVCore is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with Foobar.  If not, see <http://www.gnu.org/licenses/>
**
**  See http://www.geopsy.org for more information.
**
**  Created: 2020-05-26
**  Copyright: 2020
**    Marc Wathelet (ISTerre, Grenoble, France)
**
***************************************************************************/

#include "SpectrumRotateTool.h"
#include "SpectrumRotateStation.h"

namespace HVCore {

  /*!
    \class SpectrumRotateTool SpectrumRotateTool.h
    \brief Brief description of class still missing

    Full description of class still missing
  */

  /*!
    Description of constructor still missing
  */
  SpectrumRotateTool::SpectrumRotateTool(QObject * parent)
    : AbstractHVTool(parent)
  {
    TRACE;
    _stationSignals.setComponents(StationSignals::HorizontalComponent);
  }

  bool SpectrumRotateTool::setSubPool(SubSignalPool * subPool)
  {
    TRACE;
    if(!AbstractHVTool::setSubPool(subPool)) {
      return false;
    }
    if(!_stationSignals.addSignals(subPool) ||
       !_stationSignals.hasAllComponents()) {
      return false;
    }
    setStations();
    return true;
  }

  AbstractStation * SpectrumRotateTool::createStation(StationSignals * sigs)
  {
    return new SpectrumRotateStation(sigs);
  }

} // namespace HVCore

